<?php

namespace Schaffen\Core\Company\Models;

use Illuminate\Database\Eloquent\Model;

class CostCenter extends Model
{

   protected $useValidateRules = true;
   protected $rules = [
      'ccu_descricao' => 'string|max:50',
      'ccu_status' => 'required|integer',
      'ccu_fk_fil_codigo' => 'integer|nullable',
      'ccu_fk_ccu_codigo' => 'integer|nullable',
   ];

   protected $validationMessages = [
      'ccu_descricao.max' => "O campo 'descrição' excede o tamanho máximo de 50 caracteres.",
      'ccu_status.required' => "O campo 'status' é obrigatório.",
      'ccu_status.integer' => "O formato do campo 'status' é inválido (informar número inteiro).",
      'ccu_fk_fil_codigo.integer' => "O formato do campo 'filial' é inválido (informar número inteiro).",
      'ccu_fk_ccu_codigo.integer' => "O formato do campo 'centro de custo pai' é inválido (informar número inteiro).",
   ];

   protected $table = "financeiro.centro_custo";
   protected $primaryKey = "ccu_codigo";
   protected $fillable = ["ccu_descricao","ccu_status","ccu_fk_fil_codigo",
      "ccu_fk_ccu_codigo","ccu_admin"];
   public $timestamps = false;

   protected $casts = [
      'ccu_fk_ccu_codigo' => 'string',
   ];

   public function pai(){
      return $this->belongsTo(CostCenter::class, "ccu_fk_ccu_codigo", "ccu_codigo")->select("ccu_codigo", "ccu_descricao");
   }
   

 

   public function save(array $options = [])
   {
      //valida se o centro de custo indicado como pai não possui lançamentos
//      if (!empty($this->ccu_fk_ccu_codigo)) {
//         $this->verificaLancamentoCCU($this->ccu_fk_ccu_codigo);
//
//         if (!empty($this->ccu_codigo)) {
//            $rs = CentroCusto::where("ccu_fk_ccu_codigo", $this->ccu_codigo)->get();
//            if (count($rs) > 0) {
//               throw new \Exception("O centro de custo que está sendo editado possui filhos, portanto não pode ser indicado como filho de outro centro de custo.");
//            }
//         }
//      }

      return parent::save($options);
   }

}
