<?php


namespace Schaffen\Core\Employee\Repositories;

use Freelabois\LaravelQuickstart\Extendables\Repository;
use Schaffen\Core\Employee\Models\EmployeeMobile;

class EmployeeMobileRepository extends Repository
{
    protected $model = EmployeeMobile::class;
    protected $searchableFields = [
        ["field" => "fum_serial"],
        ["field" => "fum_libera_manutenção"]
    ];

    public function injectFiltersOnQuery(array $filters = [])
    {
        $not_blocked = null;
        extract($filters);

        $this->query->when($not_blocked, function ($query) {
            return $query->whereNull('fum_bloqueado');
        });
        parent::injectFiltersOnQuery();
    }


}
