<?php

namespace Schaffen\Core\Movement\Services;


class SalesValidateService
{

    public $response = [];
    public $id = null;
    public $messages = [];
    public $valid = true;

    public function validar_venda($values)
    {
        $this->id = $values['id'];

        $this->validade_dados_venda($values);
        $this->validade_itens($values);
        $this->validade_forma_pagamento($values);


        if (!$this->valid) {
            $this->response = [
                'status_code' => 500,
                'id' => $this->id,
                'messages' => $this->messages
            ];
        } else {
            $this->response = [
                'status_code' => 200,
                'id' => $this->id,
                'messages' => ["Sucesso"]
            ];
        }
        return $this->response;
    }

    public function validade_dados_venda($values)
    {
        if ($values['pes_codigo'] == "") {
            $this->messages[] = "O pes_codigo é obrigatório";
            $this->valid = false;
        }
    }

    public function validade_itens($values)
    {
        $itens = count($values['itens']);
        if ($itens < 1) {
            $this->messages[] = "A venda deve conter pelo menos 1 item.";
            $this->valid = false;
        } else {
            foreach ($values['itens'] as $key => $item) {
                $i = $key + 1;
                if ($item['pve_codigo'] == "") {
                    $this->messages[] = "O pve_codigo é obrigatório (item $i)";
                    $this->valid = false;
                }
                if ($item['vei_quantidade'] == "") {
                    $this->messages[] = "O vei_quantidade é obrigatório (item $i)";
                    $this->valid = false;
                }
                if ($item['vei_valor_unitario'] == "") {
                    $this->messages[] = "O vei_valor_unitario é obrigatório (item $i)";
                    $this->valid = false;
                }
                if ($item['vei_desconto'] == "") {
                    $item['vei_desconto'] = 0;
                }
            }
        }
    }

    public function validade_forma_pagamento($values)
    {
        $forma_pagamento = count($values['forma_pagamento']);
        if ($forma_pagamento < 1) {
            $this->messages[] = "A venda deve conter pelo menos uma forma de pagamento.";
            $this->valid = false;
        } else {
            foreach ($values['forma_pagamento'] as $key => $item) {
                $i = $key + 1;
                if ($item['fop_codigo'] == "") {
                    $this->messages[] = "O fop_codigo é obrigatório (forma de pagamento $i)";
                    $this->valid = false;
                }
                if ($item['vfp_valor'] == "") {
                    $this->messages[] = "O pvfp_valor é obrigatório (forma de pagamento $i)";
                    $this->valid = false;
                }
                if ($item['vfp_numero_vezes'] == "") {
                    $item['vfp_numero_vezes'] = 1;
                }
            }
        }
    }
}